/*
 @C:\Web_605\Sql\End_Conv\Oracle\3948_CDPSTPO_INGREDIENTES_PRODACAB.SQL

 Descrio:
 Procedure para gerar os ingredientes de acordo com o processo de fabricao do produto
 Material de embalagem no so exibidos
 A ordenao  por quantidade e pelo campo Ord

 Parmetros

 P_CDFILIAL     - Cdigo da filial
 P_CDPRODUTO    - Cdigo doproduto acabado

 raise_application_error(-20501, '' , True);
*/
IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
                    WHERE
	        O.NAME = 'INGREDIENTES_PRODACAB'  AND
	        TYPE = 'FN'                        AND
	        U.UID = O.UID                     AND
	        U.NAME = USER
          )
  DROP FUNCTION INGREDIENTES_PRODACAB
GO

CREATE FUNCTION INGREDIENTES_PRODACAB (
    @P_CDFILIAL   VARCHAR(4),
    @P_CDPRODUTO  VARCHAR(10),
    @P_LISTASEMI  VARCHAR(1) = 'S') RETURNS VARCHAR(5000)
AS
BEGIN
   DECLARE @V_CDESPEPROD    VARCHAR(10);
   DECLARE @V_CDTIPOCOMP    VARCHAR(03);
   DECLARE @V_RESULT        VARCHAR(5000);
   DECLARE @V_INGREDIENTES_CDPRODINSUMO VARCHAR(10);
   DECLARE @V_INGREDIENTES_NMPRODUTO    VARCHAR(250);
   DECLARE @V_INGREDIENTES_QTINSUMO     DOUBLE PRECISION;
   DECLARE @V_INGREDIENTES_IDSEMIACCOMP DOUBLE PRECISION;
   DECLARE @V_RESULT        VARCHAR(5000);
   DECLARE @V_SEMI          VARCHAR(5000);

   SELECT @V_CDESPEPROD = MAX(CDESPEPROD)
     FROM ESPEPROD
    WHERE (CDFILIAL = @P_CDFILIAL)
      AND (CDPRODUTO  = @P_CDPRODUTO)
      AND (DTVALESPEPRO = (SELECT MAX(DTVALESPEPRO)
                             FROM ESPEPROD
                            WHERE (CDFILIAL = @P_CDFILIAL)
                              AND (CDPRODUTO  = @P_CDPRODUTO)
                              AND (DTVALESPEPRO < GETDATE())));

   IF @V_CDESPEPROD IS NULL BEGIN
      SELECT @V_CDESPEPROD = MAX(E1.CDESPEPROD)
        FROM ESPEPROD E1
       WHERE (E1.CDPRODUTO  = @P_CDPRODUTO)
         AND (E1.DTVALESPEPRO = (SELECT MAX(E2.DTVALESPEPRO)
                                FROM ESPEPROD E2
                               WHERE (E1.CDFILIAL = E2.CDFILIAL)
                                 AND (E1.CDPRODUTO  = E2.CDPRODUTO)
                                 AND (E2.DTVALESPEPRO < GETDATE())));
   END;

   IF @V_CDESPEPROD IS NOT NULL BEGIN
      SELECT @V_CDTIPOCOMP = MAX(TCOMPPRO.CDTIPOCOMP)
        FROM TCOMPPRO, TIPOCOMP
       WHERE (TCOMPPRO.CDPRODUTO  = @P_CDPRODUTO )
         AND (TCOMPPRO.CDESPEPROD = @V_CDESPEPROD)
         AND (TCOMPPRO.CDTIPOCOMP = TIPOCOMP.CDTIPOCOMP)
         AND IDTCOMPPROC = 'S';

      DECLARE C_INGREDIENTES CURSOR FOR
         SELECT C.CDPRODINSUMO, ISNULL(I.NMTECNICO, P.NMPRODUTO) AS NMPRODUTO, C.QTINSUMO, C.IDSEMIACCOMP
           FROM PRODUTO P, COMPPROD C LEFT JOIN TIPOINSU T
                                        ON (C.CDTIPOINSU = T.CDTIPOINSU)
                                      LEFT JOIN INFADICPROD I
                                        ON (C.CDPRODINSUMO = I.CDPRODUTO)
          WHERE (C.CDPRODUTO    = @P_CDPRODUTO)
            AND (C.CDESPEPROD   = @V_CDESPEPROD)
            AND (C.CDTIPOCOMP   = @V_CDTIPOCOMP)
            AND (C.CDPRODINSUMO = P.CDPRODUTO)
            AND (ISNULL(T.IDTPMATERIAL, 'XXX') <> 'E')
         ORDER BY C.QTINSUMO DESC, NRORDINSUMO;
      OPEN C_INGREDIENTES;

      FETCH NEXT FROM C_INGREDIENTES INTO @V_INGREDIENTES_CDPRODINSUMO, @V_INGREDIENTES_NMPRODUTO, @V_INGREDIENTES_QTINSUMO, @V_INGREDIENTES_IDSEMIACCOMP;

      WHILE (@@FETCH_STATUS = 0) BEGIN
         IF (@V_INGREDIENTES_IDSEMIACCOMP = 'S') AND (P_LISTASEMI = 'S') BEGIN
            SET @V_SEMI := @V_INGREDIENTES_NMPRODUTO+' ('+INGREDIENTES_PRODACAB(P_CDFILIAL, @V_INGREDIENTES_CDPRODINSUMO)+'),';
         END ELSE
         BEGIN
            SET @V_RESULT = @V_RESULT + @V_SEMI + @V_INGREDIENTES_NMPRODUTO+' ';
            SET @V_SEMI := '';
         END;
         
         FETCH NEXT FROM C_INGREDIENTES INTO @V_INGREDIENTES_CDPRODINSUMO, @V_INGREDIENTES_NMPRODUTO, @V_INGREDIENTES_QTINSUMO, @V_INGREDIENTES_IDSEMIACCOMP;
      END LOOP;
   END;
   CLOSE C_INGREDIENTES;
   DEALLOCATE C_INGREDIENTES;
   RETURN(@V_RESULT);
END
GO

-- VERSAO --
EXEC ATUVEROBJ 'INGREDIENTES_PRODACAB','6.05.000';
GO

