-- ===============================================================================
-- TABLE: DADOSFORNECOMMERCE 
-- ===============================================================================
CREATE TABLE PROPCOMERCIAL
(
    NRPROPCOMERCIAL 	NUMBER NOT NULL, 
    CDFILIAL 			VARCHAR2(4) NOT NULL,
    NRORCAEVENTO 		VARCHAR2(10) NOT NULL,
    NRSEQORCAEVE 		CHAR(2) NOT NULL, 
	NMARQPROPCOM 		VARCHAR2(250) NULL,
    DSLOCALARQUIVO 		VARCHAR2(200) NOT NULL,
    IDPROPEMITIDA 		VARCHAR(2) DEFAULT 'N' NOT NULL,
    DTPROPEMITIDA 		DATE NULL,
    CDOPERADOR 			VARCHAR2(12) NULL,
    NRORG 				NUMBER DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg') NOT NULL, 
    IDATIVO 			VARCHAR2(1) DEFAULT 'S' NOT NULL, 
    DTINCLUSAO 			DATE NULL, 
    DTULTATU 			DATE NULL, 
    NRORGINCLUSAO 		NUMBER DEFAULT 1 NULL, 
    CDOPERINCLUSAO 		VARCHAR2(12) DEFAULT '1' NULL, 
    NRORGULTATU 		NUMBER DEFAULT 1 NULL, 
    CDOPERULTATU 		VARCHAR2(12) DEFAULT '1',
		CONSTRAINT CKC_IDPROPEMITIDA_PROPCOM CHECK (IDPROPEMITIDA IN ('S', 'N')),
		CONSTRAINT CKC_IDATIVO_PROPCOMERCIAL CHECK (IDATIVO IN ('S','N'))
)
/
ALTER TABLE PROPCOMERCIAL ADD CONSTRAINT PK_PROPCOMERCIAL PRIMARY KEY (NRPROPCOMERCIAL)
/
ALTER TABLE PROPCOMERCIAL ADD CONSTRAINT FKPLA00457PROPCOMER FOREIGN KEY (CDFILIAL, NRORCAEVENTO, NRSEQORCAEVE) REFERENCES ORCAEVENTO(CDFILIAL, NRORCAEVENTO, NRSEQORCAEVE)
/
CREATE INDEX FKPLA00457	ON PROPCOMERCIAL (CDFILIAL ASC, NRORCAEVENTO ASC, NRSEQORCAEVE ASC)
/  
ALTER TABLE PROPCOMERCIAL ADD CONSTRAINT FKPLA00458PROPCOMER FOREIGN KEY (CDOPERADOR) REFERENCES OPERADOR(CDOPERADOR)
/
CREATE INDEX FKPLA00458 ON PROPCOMERCIAL (CDOPERADOR ASC)